# Helm Chart 

## Limitation
osrm-extract use allot of memory and if it doesn't have enough the init container will crash and the deployment will fail. Depending on the dataset you are using make sure your pod has enough memory to process the freshly new data it's pulling on deployment.

## Configuration
Configure your ingress, PVC and settings depending on the dataset you need.
Configuring your PVC with a delete claim policy is recommended if you want to pull the latest dataset when you deploy a new version.
Configuring cors origins to your apps is suggested if you want to avoid the public using your resources.

> Copy the `values.override.example.yaml` file and rename it to `values.override.yaml`
> It's preferable using the `values.override.yaml` so you can always pull a future version of the chart without overriding your configuration.

## Debug
```bash
helm template osrm-backend .
```

## Install
```bash
helm install osrm-backend . -f values.override.yaml -n osrm
```

> Warning! Currently upgrading is not working properly because the new pod tries to attach to the same PVC as the current container. This need to be improved!

## Update
```bash
helm upgrade osrm-backend . -f values.override.yaml -n osrm
```

## Uninstall
```bash
helm uninstall osrm-backend -n osrm
```

check init containers status
```bash
kubectl logs <pod-id> -c <container-name> -n osrm -f
```

default init containers
```
osrm-download
osrm-init
```

check logs of the running pod
```bash
kubectl logs <pod-id> -n osrm -f
```

## Improvements
- [ ] Allow multiple init container configuration to process multiple `.osm.pbf` files
- [ ] Make PVC Dynamic per release to allow upgrading the helm chart (this also make sure to pull the latest datasets)
